/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.log.enums.YYLoggerTuJingEnum
 *  fire.pb.activity.award.RewardMgr
 *  fire.pb.activity.award.RewardObjs
 *  fire.pb.battle.BasicEndHandler
 *  fire.pb.map.SceneNpcManager
 *  fire.pb.team.Team
 *  fire.pb.team.TeamManager
 *  mkdb.Lockey
 *  mkdb.Lockeys
 *  mkdb.TTable
 *  xbean.Fighter
 *  xbean.InstanceInfo
 *  xbean.InstanceInfoCol
 *  xbean.InstanceTaskInfo
 *  xtable.Instancetask
 *  xtable.Locks
 *  xtable.Properties
 *  xtable.Roleinstancetask
 */
package fire.pb.mission.instance;

import fire.log.enums.YYLoggerTuJingEnum;
import fire.pb.activity.award.RewardMgr;
import fire.pb.activity.award.RewardObjs;
import fire.pb.battle.BasicEndHandler;
import fire.pb.map.SceneNpcManager;
import fire.pb.mission.instance.InstanceManager;
import fire.pb.mission.instance.LevelGroupAward;
import fire.pb.mission.instance.ServiceConfig;
import fire.pb.team.Team;
import fire.pb.team.TeamManager;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import mkdb.Lockey;
import mkdb.Lockeys;
import mkdb.TTable;
import xbean.Fighter;
import xbean.InstanceInfo;
import xbean.InstanceInfoCol;
import xbean.InstanceTaskInfo;
import xtable.Instancetask;
import xtable.Locks;
import xtable.Properties;
import xtable.Roleinstancetask;

public class InstanceBattleEndHandler
extends BasicEndHandler {
    final ServiceConfig serviceConfig;
    private final int serviceId;
    private final long npcKey;
    private final long instanceOnlyId;
    private final int instanceId;

    public InstanceBattleEndHandler(ServiceConfig serviceConfig, int serviceId, long npcKey, long instanceOnlyId, int instanceId) {
        this.serviceConfig = serviceConfig;
        this.serviceId = serviceId;
        this.npcKey = npcKey;
        this.instanceOnlyId = instanceOnlyId;
        this.instanceId = instanceId;
    }

    protected void transformAfterBattle() {
    }

    protected boolean handleAward() {
        InstanceInfo instInfo = Instancetask.get((Long)this.instanceOnlyId);
        if (instInfo == null) {
            return false;
        }
        List winFighters = this.getWinRoles();
        if (winFighters.isEmpty()) {
            winFighters = this.getDeadRoles();
        }
        Team team = TeamManager.selectTeamByRoleId((long)((Fighter)winFighters.get(0)).getUniqueid());
        int totalRound = instInfo.getFinalcounts() + this.battle.getRound();
        instInfo.setFinalcounts(totalRound);
        int step = instInfo.getCurrentstep();
        ArrayList roleids = new ArrayList(4);
        if (team != null) {
            roleids.addAll(team.getNormalMemberIds());
        } else {
            roleids.addAll(instInfo.getRoleids());
        }
        Lockeys.lock((Lockey[])Lockeys.get((TTable)Locks.ROLEINSTANCETASK, roleids));
        int matchLevel = 0;
        LevelGroupAward award = null;
        if (this.serviceConfig.matchtype == 2) {
            for (Long rid : this.battle.getRoleids().keySet()) {
                int roleLevel = Properties.selectLevel((Long)rid);
                matchLevel += roleLevel;
            }
            matchLevel /= this.battle.getRoleids().size();
            for (LevelGroupAward awards : this.serviceConfig.groupAward) {
                if (matchLevel < awards.levelmin || matchLevel > awards.levelmax) continue;
                award = awards;
            }
        }
        for (Long rid : this.battle.getRoleids().keySet()) {
            RewardObjs item;
            InstanceTaskInfo info;
            InstanceInfoCol taskInfo;
            if (!roleids.contains(rid) || (taskInfo = Roleinstancetask.get((Long)rid)) == null || (info = (InstanceTaskInfo)taskInfo.getInstinfo().get(this.instanceId)) == null) continue;
            HashMap<String, Integer> paras = new HashMap<String, Integer>(10);
            this.putBattleParas(paras);
            paras.put("Time", 1);
            paras.put("IsTL", team != null && team.isTeamLeader(rid.longValue()) ? 1 : 0);
            paras.put("Ring", step);
            Integer awardTimes = (Integer)info.getStepawardtimes().get(step);
            int roleLevel = Properties.selectLevel((Long)rid);
            Map awardResult = null;
            if (awardTimes == null) {
                awardTimes = 1;
                if (this.serviceConfig.matchtype == 1) {
                    for (LevelGroupAward awards : this.serviceConfig.groupAward) {
                        if (roleLevel < awards.levelmin || roleLevel > awards.levelmax) continue;
                        awardResult = RewardMgr.getInstance().distributeAllAward(rid.longValue(), awards.awardid, paras, YYLoggerTuJingEnum.tujing_Value_fubenjiangli, awards.awardid, 4001, "副本战斗胜利奖励", true);
                        break;
                    }
                } else if (this.serviceConfig.matchtype == 2 && award != null) {
                    awardResult = RewardMgr.getInstance().distributeAllAward(rid.longValue(), award.awardid, paras, YYLoggerTuJingEnum.tujing_Value_fubenjiangli, award.awardid, 4001, "副本战斗胜利奖励", true);
                }
                info.getStepawardtimes().put(step, awardTimes);
            } else if (awardTimes < this.serviceConfig.sAwardTimes) {
                if (this.serviceConfig.matchtype == 1) {
                    for (LevelGroupAward awards : this.serviceConfig.groupAward) {
                        if (roleLevel < awards.levelmin || roleLevel > awards.levelmax) continue;
                        awardResult = RewardMgr.getInstance().distributeAllAward(rid.longValue(), awards.awardid, paras, YYLoggerTuJingEnum.tujing_Value_fubenjiangli, awards.awardid, 4001, "副本战斗胜利奖励", true);
                        break;
                    }
                } else if (this.serviceConfig.matchtype == 2 && award != null) {
                    awardResult = RewardMgr.getInstance().distributeAllAward(rid.longValue(), award.awardid, paras, YYLoggerTuJingEnum.tujing_Value_fubenjiangli, award.awardid, 4001, "副本战斗胜利奖励", true);
                }
                info.getStepawardtimes().put(step, awardTimes + 1);
            } else if (awardTimes < this.serviceConfig.ptAwardidTimes + this.serviceConfig.sAwardTimes) {
                awardResult = RewardMgr.getInstance().distributeAllAward(rid.longValue(), this.serviceConfig.ptAwardid, paras, YYLoggerTuJingEnum.tujing_Value_fubenjiangli, this.serviceConfig.ptAwardid, 4001, "副本战斗胜利奖励", true);
                info.getStepawardtimes().put(step, awardTimes + 1);
            }
            int exp = info.getTotalexp();
            info.setTotalexp(exp);
            if (awardResult == null || (item = (RewardObjs)awardResult.get(5)) == null) continue;
            info.setTotalexp(info.getTotalexp() + (int)item.getValue());
        }
        SceneNpcManager.premoveNpcWhileCommit((long)this.npcKey);
        InstanceManager.getInstance().doNextStep(instInfo, this.serviceId, this.instanceId, this.instanceOnlyId);
        return true;
    }
}

